using System;
using System.Runtime.InteropServices;
namespace ParalelPortApp2
{
	/// <summary>
	/// Summary description for InpOut.
	/// </summary>
	public class InpOut
	{
		[DllImport("Inpout32.dll")]
		public static extern short Inp32(int address);
		[DllImport("Inpout32.dll")]
		public static extern short  Out32(int address,int data);
		
		//private int baseadres=0x378;

		public static void WriteDataPort(int baseadres,int data)
		{
			Out32(baseadres,data);
		}
		

		

		public static void ToggleDataPortBit(int base_address,int bitNo)
		{
			
			int port_data=Inp32(base_address);
			int bitWeight=(int)System.Math.Pow(2,bitNo);
			int data=port_data & bitWeight ;
			
				
				
			if (data ==bitWeight) {port_data=port_data - bitWeight;}
			else{ port_data=port_data | bitWeight;}
				
		
			Out32(base_address,port_data);
			

		}
		public static int ReadStatusPort(int base_address)
		{
			int data= Inp32(base_address+1);
			data=data & 120;
			return (data >> 3);

		}
		
		public static  void WriteControlPort(int base_address,int port_data)
		{
			int data=port_data & 1 ;
			if (data ==1) {port_data=port_data & (255-1);}
			else{ port_data=port_data | 1;}
			
			data=port_data & 2 ;
			if (data ==2) {port_data=port_data & (255-2);}
			else{ port_data=port_data | 2;}
			data=port_data & 8;
			if (data ==8) {port_data=port_data & (255-8);}
			else{ port_data=port_data | 8;}
			Out32(base_address+2,port_data);//output a byte to control port.
		}

		public static  void ToggleControlPortBit(int base_address,int bitNo)
		{
			int port_data=Inp32(base_address+2);
			int bitWeight=(int)System.Math.Pow(2,bitNo);
			int data=port_data & bitWeight ;
			
				
				
				if (data ==bitWeight) {port_data=port_data - bitWeight;}
				else{ port_data=port_data | bitWeight;}
				
		
			Out32(base_address+2,port_data);
			
			
		}

		

	}
}
